package tdspp.DeploymentAdvisor;

import Prism.core.* ;
import tdspp.util.*;
import java.util.*;

/**
 * The deployment advisor component. Makes use of class DeploymentAdvisorImp.
 *
 * @see		DeploymentAdvisorImp
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 18 Feb 2002
 *
*/

public class DeploymentAdvisor extends AbstractImplementation {
	/**
	 * The WeatherAnalyzerImp object
	 *
	 */
	DeploymentAdvisorImp daIO;
	Event n, nn;
	Event r, rr;
	String name;

	/**
	 * Default constructor
	 */
	public DeploymentAdvisor() {
		this("DeploymentAdvisor");
	}

	public DeploymentAdvisor (String name){
		
		daIO = new DeploymentAdvisorImp ();
		this.name = name;
	}


	/**
	 * Handling the Requests
	 *
	 * @param r	Request
	 * @return 	void
	 *
	 */
	public void handle (Event r) {
		if (r.name.equals (tdspp.util.MessageConstants.MESSAGE_NAME_ADVISEDEPLOYMENT )){
			daIO.setRegions ((Region[]) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS ));

			//SAKB communication
			rr = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_GETRULES );
			rr.eventType=PrismConstants.REQUEST;
			rr.addParameter (tdspp.util.MessageConstants.PARAM_NAME_ID , new String (name));
			send (rr);

		}
		
		if (r.name.equals (tdspp.util.MessageConstants.MESSAGE_NAME_GETRULESRESP)){
			String idName = (String) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_ID );
			if (idName.equals(name)){

				daIO.setLocalRules ((Hashtable) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_GETRULESRESP ));
				daIO.adviseDeployment ();
				nn = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_ADVISEDEPLOYMENTRESP );
				nn.eventType=PrismConstants.REPLY;
				nn.addParameter (tdspp.util.MessageConstants.PARAM_NAME_DEPLOYRESPREGION , daIO.getDeployRegion ());
				nn.addParameter (tdspp.util.MessageConstants.PARAM_NAME_DEPLOYRESPLEVEL , daIO.getDeployLevel ());

				send (nn);
			}

		}

		//send(n);
	}
}
