
package tdspp.RenderingAgent;

import java.util.*;
import tdspp.util.*;
import Prism.core.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
/**
 * The bottom panel
 * This is defined as a local class as it is used only by the RenderingAgent.
 */

public class BottomPanel extends Panel {
	/**
	 * Parent Rendering Agent.
	 */
	public RenderingAgentImp parent;

	/**
	 * The parent frame
	 */
	public TDSMainFrame frm;

	/**
	 * Buttons
	 */
	Button buttons[];

	/**
	 * Menus
	 */
	PopupMenu popupMenus[];

	/**
	 * Constructor
	 */
	public BottomPanel(RenderingAgentImp par, TDSMainFrame pfrm) {
		super();
		parent = par;
		frm = pfrm;
		// count buttons
		int noOfButtons = tdspp.util.Constants.BOTTOMPANEL_BUTTON_LABELS.length;
		buttons = new Button[noOfButtons];
		// create popup menus
		popupMenus = new PopupMenu[noOfButtons];
		try {
			Class paramTypes[] = { this.getClass() };
			Object params[] = { this };
			java.lang.reflect.Constructor c;
			for(int i = 0; i < noOfButtons; i++) {
				popupMenus[i] = new PopupMenu();
				for(int j = 0; j < tdspp.util.Constants.BOTTOMPANEL_MENUS[i].length; j++) {
					MenuItem mi = new MenuItem(tdspp.util.Constants.BOTTOMPANEL_MENUS[i][j]);
					c = Class.forName(tdspp.util.Constants.BOTTOMPANEL_ACTIONS[i][j]).getConstructor(paramTypes);
					mi.addActionListener((ActionListener)c.newInstance(params));
					popupMenus[i].add(mi);
				}
				add(popupMenus[i]);
			}
		}catch(Exception e) {
			System.out.println(e);
		}
		// create buttons
		for(int i = 0; i < noOfButtons; i++) {
			buttons[i] = new Button(tdspp.util.Constants.BOTTOMPANEL_BUTTON_LABELS[i]);
			buttons[i].setSize(tdspp.util.Constants.MAINFRAME_MAP_SIDE/noOfButtons,tdspp.util.Constants.MAINFRAME_HEIGHT - tdspp.util.Constants.MAINFRAME_WIDTH - tdspp.util.Constants.MAINFRAME_CAPTION_HEIGHT);
			buttons[i].addActionListener(new ActionListener () {
				public void actionPerformed(ActionEvent ev) {
					if(ev.getSource() instanceof Button) {
						Button src = (Button) ev.getSource();
						if((BottomPanel.this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_GETTING ||BottomPanel.this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_DEPLOYADV || BottomPanel.this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_SIMULATION)&& src.getLabel().equals(tdspp.util.Constants.BOTTOMPANEL_BUTTON_CANCEL)) {
							BottomPanel.this.frm.tp.repaint();
							BottomPanel.this.parent.modeGUI = tdspp.util.Constants.RENDERINGAGENT_MODE_NORMAL;
							BottomPanel.this.updateGUIMode();
						} else if(BottomPanel.this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_SIMACCEPT) {
							if(src.getLabel().equals(tdspp.util.Constants.BOTTOMPANEL_BUTTON_ACCEPT)) {
								//System.out.println("Accept pressed");
							} else if(src.getLabel().equals(tdspp.util.Constants.BOTTOMPANEL_BUTTON_REJECT)) {
										RenderingAgentImp ra = BottomPanel.this.frm.parent;
										Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_DONTSAVEFIGHT);
										req.eventType=PrismConstants.REQUEST;
										ra.parent.send(req);
							}
							BottomPanel.this.frm.tp.repaint();
							for(int j=0;j<buttons.length;j++) {
								buttons[j].setVisible(true);
								buttons[j].setLabel(tdspp.util.Constants.BOTTOMPANEL_BUTTON_LABELS[j]);
							}
							BottomPanel.this.parent.modeGUI = tdspp.util.Constants.RENDERINGAGENT_MODE_NORMAL;
						} else {

							for(int index = 0; index < tdspp.util.Constants.BOTTOMPANEL_BUTTON_LABELS.length; index++) {
								if(src.getLabel().equals(tdspp.util.Constants.BOTTOMPANEL_BUTTON_LABELS[index])) {
									BottomPanel.this.popupMenus[index].show(src,10,10);
									break;
								}
							}
						}
					}
				}
				});
			add(buttons[i]);
		}
	}

	/**
	 * The paint method
	 */
	public void paint(Graphics g) {
		super.paint(g);
		g.setColor(Color.blue);
		g.drawLine(0,1,tdspp.util.Constants.MAINFRAME_WIDTH-1,1);
	}

	/**
	 * Show deployment advice
	 */
	public void updateGUIMode() {
		if(this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_DEPLOYADV ||
		   this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_SIMULATION ||
		   this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_GETTING) {
			for(int i=0;i<buttons.length;i++)
				buttons[i].setVisible(false);
			buttons[tdspp.util.Constants.BOTTOMPANEL_BUTTON_CANCELIDX].setLabel(tdspp.util.Constants.BOTTOMPANEL_BUTTON_CANCEL);
			buttons[tdspp.util.Constants.BOTTOMPANEL_BUTTON_CANCELIDX].setVisible(true);
		} else if(this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_SIMACCEPT) {
			for(int i=0;i<buttons.length;i++)
				buttons[i].setVisible(false);
			buttons[tdspp.util.Constants.BOTTOMPANEL_BUTTON_ACCEPTIDX].setLabel(tdspp.util.Constants.BOTTOMPANEL_BUTTON_ACCEPT);
			buttons[tdspp.util.Constants.BOTTOMPANEL_BUTTON_ACCEPTIDX].setVisible(true);
			buttons[tdspp.util.Constants.BOTTOMPANEL_BUTTON_REJECTIDX].setLabel(tdspp.util.Constants.BOTTOMPANEL_BUTTON_REJECT);
			buttons[tdspp.util.Constants.BOTTOMPANEL_BUTTON_REJECTIDX].setVisible(true);
		} else if(this.parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_NORMAL) {
			buttons[tdspp.util.Constants.BOTTOMPANEL_BUTTON_CANCELIDX].setLabel(tdspp.util.Constants.BOTTOMPANEL_BUTTON_LABELS[tdspp.util.Constants.BOTTOMPANEL_BUTTON_CANCELIDX]);
			for(int j=0;j<buttons.length;j++)
				buttons[j].setVisible(true);
		}
	}

	/**
	 * Action listener classes
	 */
	public class SimulateAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			RenderingAgentImp ra = BottomPanel.this.frm.parent;
			ra.modeGUI = tdspp.util.Constants.RENDERINGAGENT_MODE_STARTSIM;
			Prism.core.Event  req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_SIMULATEFIGHT);
			req.eventType=PrismConstants.REQUEST;
			req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS,ra.regions);
			ra.parent.send(req);
		}
	}
	public class DeployAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			RenderingAgentImp ra = BottomPanel.this.frm.parent;
			Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_ADVISEDEPLOYMENT);
			req.eventType=PrismConstants.REQUEST;
			req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS,ra.regions);
			ra.parent.send(req);
		}
	}
	public class StrategyAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			RenderingAgentImp ra = BottomPanel.this.frm.parent;
			Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGY);
			req.eventType=PrismConstants.REQUEST;
			req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS,ra.regions);
			ra.parent.send(req);
		}
	}
	public class KBAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			RenderingAgentImp ra = BottomPanel.this.frm.parent;
			Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_SHOWSAKBUI);
			req.eventType=PrismConstants.REQUEST;
			//req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_SHOWSAKBUI_PARENT,BottomPanel.this.frm);
			ra.parent.send(req);
		}
	}
	public class WeatherAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			TDSMainFrame frm = BottomPanel.this.frm;
			if(frm.cellX == -1) return;
			Region reg = new Region();
			reg = BottomPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
			String str[] = { "Weather Info", "Temperature : " + reg.weatherInfo.temperature,
							"Humidity    : " + reg.weatherInfo.humidity,
							"WindSpeed   : " + reg.weatherInfo.windSpeed,
							 "Sunlight    : " + reg.weatherInfo.sunlight };
			BottomPanel.DialogBox dlg = BottomPanel.this.new DialogBox("Cell Info",str,null, tdspp.util.Constants.DIALOG_BOXTYPE_INFO);
			dlg.show();
		}
	}
	public class MoveAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			TDSMainFrame frm = BottomPanel.this.frm;
			if(frm.cellX == -1) return;

			Region reg = new Region();
			reg = BottomPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
			if(!hasResources(reg)) return;
			BottomPanel.DialogBox dlg = BottomPanel.this.new DialogBox("Cell Info",null,reg, tdspp.util.Constants.DIALOG_BOXTYPE_MOVE);
			dlg.show();
		}
	}
	public class UpdateAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			TDSMainFrame frm = BottomPanel.this.frm;
			if(frm.cellX == -1) return;
			Region reg = new Region();
			reg = BottomPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
			BottomPanel.DialogBox dlg = BottomPanel.this.new DialogBox("Cell Info",null,reg,tdspp.util.Constants.DIALOG_BOXTYPE_UPDATE);
			dlg.show();
		}
	}
	public class LogAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
		}
	}

	private boolean hasResources(Region reg) {
		return (reg.armyRes.isInfantry() || reg.armyRes.isTank() || reg.armyRes.isMineField() ||
			reg.armyRes.isEnemyInfantry() || reg.armyRes.isEnemyTank());
	}
	public class SaveAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			RenderingAgentImp ra = BottomPanel.this.frm.parent;
			Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_SAVESTATE);
			req.eventType=PrismConstants.REQUEST;
			ra.parent.send(req);
		}
	}
	public class TempUpdateAction implements ActionListener {
		public void actionPerformed(ActionEvent ev) {
			TDSMainFrame frm = BottomPanel.this.frm;
			if(frm.cellX == -1) return;
			Region reg = new Region();
			reg = BottomPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
			BottomPanel.DialogBox dlg = BottomPanel.this.new DialogBox("Cell Info",null,reg,tdspp.util.Constants.DIALOG_BOXTYPE_UPDATEDATA);
			dlg.show();
		}
	}
	public class DialogBox extends Dialog {
		/**
		 * Checkboxes for army resources
		 */
		Checkbox arr[];
		int arrNum;
		java.awt.Component carr[];

		public DialogBox(String title, String text[], Region reg, int type) {
			super(BottomPanel.this.frm,title,true);
			int items = 4;
			if(text != null) {
				items = text.length;
				setLayout(new GridLayout(items,1));
				Label lbl[] = new Label[items];
				for(int i = 0; i < items; i++) {
					lbl[i] = new Label(text[i]);
					add(lbl[i]);
				}
			}
			if(reg != null) {
				//System.out.println("Type >> " + type);
				if(type == tdspp.util.Constants.DIALOG_BOXTYPE_UPDATE) {
					int noOfChks = tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length + tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk.length;
					items = noOfChks + 1;
					setLayout(new GridLayout(items,1));
					arr = new Checkbox[noOfChks];
					arrNum = noOfChks;
					for(int i=0;i<tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length;i++) {
						arr[i] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[i]);
						if(i == 0 && reg.armyRes.isInfantry())
							arr[i].setState(true);
						if(i == 1 && reg.armyRes.isTank())
							arr[i].setState(true);
						if(i == 2 && reg.armyRes.isMineField())
							arr[i].setState(true);
						arr[i].setEnabled(BottomPanel.this.frm.mySubmap);
						add(arr[i]);
					}
					for(int i=0;i<tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk.length;i++) {
						arr[i+tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[i]);
						if(i == 0 && reg.armyRes.isEnemyInfantry())
							arr[i+tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length].setState(true);
						if(i == 1 && reg.armyRes.isEnemyTank())
							arr[i+tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length].setState(true);
						arr[i+tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length].setEnabled(false);
						add(arr[i+tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length]);
					}
					Button b = new Button("Update");
					b.setEnabled(BottomPanel.this.frm.mySubmap);
					b.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent ev) {
							TDSMainFrame frm = BottomPanel.this.frm;
							if(frm.cellX == -1) return;
							Region regAL = new Region();
							regAL = BottomPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
							int addCounter = 0, removeCounter = 0;
							String addResourceNames[], removeResourceNames[];
							addResourceNames = new String[5];
							removeResourceNames = new String[5];
							int counters[];
							setVisible(false);
							frm.tp.drawIcons(regAL,null,true);
							counters = readDialogBox(regAL,addResourceNames, addCounter,removeResourceNames, removeCounter);
							addCounter = counters[0];
							removeCounter = counters[1];

							if(addCounter > 0) {
								RenderingAgentImp ra = BottomPanel.this.frm.parent;
								Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_UPDATERESOURCES);
								req.eventType=PrismConstants.REQUEST;
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_UPDATERESOURCES_OPERATIONFLAG, new Integer(1));
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_UPDATERESOURCES_REGION,regAL);
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_UPDATERESOURCES_RESOURCENAMES,addResourceNames);
								//System.out.println("sending from addCounter>0 :"+regAL.armyRes.resources);
								ra.parent.send(req);
							}

							if(removeCounter > 0) {
								RenderingAgentImp ra = BottomPanel.this.frm.parent;
								Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_UPDATERESOURCES);
								req.eventType=PrismConstants.REQUEST;
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_UPDATERESOURCES_OPERATIONFLAG, new Integer(-1));
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_UPDATERESOURCES_REGION,regAL);
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_UPDATERESOURCES_RESOURCENAMES,removeResourceNames);
								//System.out.println("sending from removeCounter>0 :"+regAL.armyRes.resources);
								ra.parent.send(req);
							}
							dispose();
//							System.out.println("TEMP: BOTTOM PANEL: " + regAL);
							frm.tp.updateCell(regAL);
						}
						});
					add(b);
				}
				else if (type == tdspp.util.Constants.DIALOG_BOXTYPE_MOVE) {
					int noOfChks = tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length + tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk.length;
					arr = new Checkbox[noOfChks];
					arrNum = 0;
					for(int i=0;i<tdspp.util.Constants.DIALOG_CHECKBOXES_updChk.length;i++) {

						if(i == 0 && reg.armyRes.isInfantry()) {
							arr[arrNum] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[i]);
							//arr[arrNum].setState(true);
							arrNum++;
						}
						if(i == 1 && reg.armyRes.isTank()) {
							arr[arrNum] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[i]);
							//arr[arrNum].setState(true);
							arrNum++;
						}
						//System.out.println("Arr Num 1 >> " + arrNum);
						if(arrNum > 0) {
							arr[arrNum-1].setEnabled(BottomPanel.this.frm.mySubmap);
							add(arr[arrNum-1]);
						}
					}
/*
					System.out.println("tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk.length" + tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk.length);
					System.out.println("reg.armyRes.isMineField() " + reg.armyRes.isMineField() );
					System.out.println("reg.armyRes.isEnemyInfantry()" + reg.armyRes.isEnemyInfantry());
					System.out.println("reg.armyRes.isEnemyTank() " + reg.armyRes.isEnemyTank() );
*/
					for(int i=0;i<tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk.length;i++) {
						if(i == 0 && reg.armyRes.isMineField()) {
							arr[arrNum] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[i]);
							//arr[arrNum].setState(true);
							arrNum++;
						}

						if(i == 1 && reg.armyRes.isEnemyInfantry()) {
							arr[arrNum] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[i]);
							//arr[arrNum].setState(true);
							arrNum++;
						}
						if(i == 2 && reg.armyRes.isEnemyTank()) {
							arr[arrNum] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[i]);
							//arr[arrNum].setState(true);
							arrNum++;
						}
						//System.out.println("Arr Num 2 >> " + arrNum);
						if(arrNum > 0) {
							arr[arrNum-1].setEnabled(BottomPanel.this.frm.mySubmap);
							add(arr[arrNum-1]);
						}
					}

					items = arrNum + 1;
					setLayout(new GridLayout(items,1));
					Button b = new Button("Move To .....");
					b.setEnabled(BottomPanel.this.frm.mySubmap);
					b.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent ev) {
							TDSMainFrame frm = BottomPanel.this.frm;
							if(frm.cellX == -1) return;
							//System.out.println("Moving....");
							Region regAL = new Region();
							regAL = BottomPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
							int addCounter = 0, removeCounter = 0;
							String addResourceNames[], removeResourceNames[];
							addResourceNames = new String[5];
							removeResourceNames = new String[5];
							int counters[];
							//System.out.println("reading diaolog....");
							counters = readDialogBox(regAL,addResourceNames, addCounter,removeResourceNames, removeCounter);
							addCounter = counters[0];
							removeCounter = counters[1];
							BottomPanel.this.parent.moveFlag = true;



							if(addCounter > 0) {
								RenderingAgentImp ra = BottomPanel.this.frm.parent;
								Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_MOVERESOURCES);
								req.eventType=PrismConstants.REQUEST;
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_MOVERESOURCES_OPERATIONFLAG, new Integer(2));
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_MOVERESOURCES_FROMREGION,regAL);
								req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_MOVERESOURCES_RESOURCENAMES,addResourceNames);
								ra.saveRequest(req);
							}

//							System.out.println("TEMP: BOTTOM PANEL: " + regAL);
							dispose();
							frm.tp.updateCell(regAL);
						}
					});

					add(b);
				} else if (type == tdspp.util.Constants.DIALOG_BOXTYPE_UPDATEDATA) {
					int noOfChks = tdspp.util.Constants.DIALOG_CHECKBOXES_updData.length;
					int noOfTexts = tdspp.util.Constants.DIALOG_TEXTBOXES_updData.length;
					int noOfLists = tdspp.util.Constants.DIALOG_LISTBOXES_updData.length;
					items = noOfChks + noOfTexts + noOfLists + 1;
					setLayout(new GridLayout(items,2));
					arr = new Checkbox[noOfChks];
					carr = new java.awt.Component[noOfTexts + noOfLists];
					arrNum = noOfChks;
					int done = 0;
					for(int i=0;i<tdspp.util.Constants.DIALOG_CHECKBOXES_updData.length;i++) {
						arr[i] = new Checkbox(tdspp.util.Constants.DIALOG_CHECKBOXES_updData[i]);
						if(i == 0 && reg.armyRes.isEnemyInfantry())
							arr[i].setState(true);
// <changed vishal
					if(i == 1 && reg.armyRes.isEnemyTank())
// changed vishal>
							arr[i].setState(true);
						arr[i].setEnabled(BottomPanel.this.frm.mySubmap);
						add(arr[i]);
						add(new Label(""));
					}
					for(int i=0;i<tdspp.util.Constants.DIALOG_TEXTBOXES_updData.length;i++) {
						carr[i+done] = new TextField(5);
						if(i == 0)
							((TextField)carr[i+done]).setText("" + reg.armyRes.stateAmmunition);
						if(i == 1)
							((TextField)carr[i+done]).setText("" + reg.armyRes.stateFood);
						if(i == 2)
							((TextField)carr[i+done]).setText("" + reg.armyRes.statePopulation);
						if(i == 3)
							((TextField)carr[i+done]).setText("" + reg.weatherInfo.temperature);
						if(i == 4)
							((TextField)carr[i+done]).setText("" + reg.weatherInfo.humidity);
						if(i == 5)
							((TextField)carr[i+done]).setText("" + reg.weatherInfo.windSpeed);
						if(i == 6)
							((TextField)carr[i+done]).setText("" + reg.weatherInfo.sunlight);
						add(new Label(tdspp.util.Constants.DIALOG_TEXTBOXES_updData[i]));
						carr[i+done].setEnabled(BottomPanel.this.frm.mySubmap);
						add(carr[i+done]);
					}
					done += noOfTexts;
					for(int i=0;i<tdspp.util.Constants.DIALOG_LISTBOXES_updData.length;i++) {
						carr[i+done] = new java.awt.List(1);
						if(i == 0) {
							for(int j=0;j<tdspp.util.Constants.DIALOG_TERRAINTYPE_DESC.length;j++) {
								((java.awt.List)carr[i+done]).add(tdspp.util.Constants.DIALOG_TERRAINTYPE_DESC[j]);
								if(reg.terrainDesc.type == tdspp.util.Constants.DIALOG_TERRAINTYPE_VALS[j]) {
									((java.awt.List)carr[i+done]).select(j);
									((java.awt.List)carr[i+done]).makeVisible(j);
								}
							}
						 }
						add(new Label(tdspp.util.Constants.DIALOG_LISTBOXES_updData[i]));
						carr[i+done].setEnabled(BottomPanel.this.frm.mySubmap);
						add(carr[i+done]);
					}
					Button b = new Button("Update");
					b.setEnabled(BottomPanel.this.frm.mySubmap);
					b.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent ev) {
							TDSMainFrame frm = BottomPanel.this.frm;
							if(frm.cellX == -1) return;
							Region regAL = new Region();
							regAL = BottomPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
							setVisible(false);
							frm.tp.drawIcons(regAL,null,true);
							String name;
							if(DialogBox.this.arr != null) {
								for(int i=0; i<arr.length; i++) {
									if(arr[i].getState()) {
										name = new String(arr[i].getLabel());

// < changeded by Vishal
										if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updData[0]))
											regAL.armyRes.setEnemyInfantry();
										if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updData[1]))
											regAL.armyRes.setEnemyTank();
// changed by vishal >
									}
								}
							}
							if(DialogBox.this.carr != null) {
								for(int i=0; i<tdspp.util.Constants.DIALOG_TEXTBOXES_updData.length; i++) {
									if(i == 0)
										regAL.armyRes.stateAmmunition = new Float(((TextField)carr[i]).getText()).floatValue();
									if(i == 1)
										regAL.armyRes.stateFood = new Float(((TextField)carr[i]).getText()).floatValue();
									if(i == 2)
										regAL.armyRes.statePopulation = new Float(((TextField)carr[i]).getText()).floatValue();
									if(i == 3)
										regAL.weatherInfo.temperature = new Float(((TextField)carr[i]).getText()).floatValue();
									if(i == 4)
										regAL.weatherInfo.humidity = new Float(((TextField)carr[i]).getText()).floatValue();
									if(i == 5)
										regAL.weatherInfo.windSpeed = new Float(((TextField)carr[i]).getText()).floatValue();
									if(i == 6)
										regAL.weatherInfo.sunlight = (int)new Float(((TextField)carr[i]).getText()).floatValue();
								}
								for(int i=tdspp.util.Constants.DIALOG_TEXTBOXES_updData.length;i<carr.length; i++) {
									if(i == tdspp.util.Constants.DIALOG_TEXTBOXES_updData.length)
										regAL.terrainDesc.type = tdspp.util.Constants.DIALOG_TERRAINTYPE_VALS[((java.awt.List)carr[i]).getSelectedIndex()];
								}
							}

							dispose();
							Prism.core.Event r = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_SETATTR);
							r.eventType=PrismConstants.REQUEST;
							r.addParameter(tdspp.util.MessageConstants.PARAM_NAME_SETATTR_REGION,regAL);
							frm.tp.parent.parent.send(r);
							frm.tp.updateCell(regAL);
						}
						});
					add(b);
				}
			}

			addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					dispose();
				}
			});
			if (type == tdspp.util.Constants.DIALOG_BOXTYPE_UPDATEDATA)
				setSize(tdspp.util.Constants.MAINFRAME_WIDTH*9/10,tdspp.util.Constants.MAINFRAME_HEIGHT*9/10);
			else
				setSize(tdspp.util.Constants.MAINFRAME_WIDTH*5/8,tdspp.util.Constants.MAINFRAME_HEIGHT*5/8);
		}

		private int[] readDialogBox(Region regAL, String addResourceNames[], int addCounter,
							String removeResourceNames [], int removeCounter) {
			String name;
			if(arr != null) {
				for(int i = 0; i < arrNum; i++) {

					if(arr[i].getState()) {
						//System.out.println("Label " + i + " " + arr[i].getLabel());
						name = new String(arr[i].getLabel());
						addResourceNames[addCounter] = name;
						addCounter++;
						//System.out.println("increased counter.......");
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[0])) {
							if(!regAL.armyRes.isInfantry()) {
								regAL.armyRes.setStateAmmunition((float)1.0);
								regAL.armyRes.setStateFood((float)1.0);
								regAL.armyRes.setStatePopulation((float)1.0);
							}
							regAL.armyRes.setInfantry();
						}
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[1])) {
							if(!regAL.armyRes.isTank()) {
								regAL.armyRes.setStateAmmunition((float)1.0);
								regAL.armyRes.setStateFood((float)1.0);
								regAL.armyRes.setStatePopulation((float)1.0);
							}
							regAL.armyRes.setTank();
						}
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[2]))
							regAL.armyRes.setMineField();
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[0]))
							regAL.armyRes.setEnemyInfantry();
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[1]))
							regAL.armyRes.setEnemyTank();
						//System.out.println("checked states.......");
					}
					else {
//						System.out.println("TEMP: BOTTOM PANEL remove >> " + arr[i].getLabel());
						name = new String(arr[i].getLabel());
						removeResourceNames[removeCounter] = name;
						removeCounter++;
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[0])) {
							regAL.armyRes.setStateAmmunition((float)0.0);
							regAL.armyRes.setStateFood((float)0.0);
							regAL.armyRes.setStatePopulation((float)0.0);
							regAL.armyRes.removeInfantry();
						}
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[1])) {
							regAL.armyRes.setStateAmmunition((float)0.0);
							regAL.armyRes.setStateFood((float)0.0);
							regAL.armyRes.setStatePopulation((float)0.0);
							regAL.armyRes.removeTank();
						}
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_updChk[2]))
							regAL.armyRes.removeMineField();
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[0]))
							regAL.armyRes.removeEnemyInfantry();
						if(name.equalsIgnoreCase(tdspp.util.Constants.DIALOG_CHECKBOXES_unUpdChk[1]))
							regAL.armyRes.removeEnemyTank();

					}
				}
			}
/*			System.out.println("TEMP: BOTTOM PANEL add >> " + addCounter);
			for(int i = 0; i < addCounter; i++) {
				System.out.println("TEMP: BOTTOM PANEL add names >> " + addResourceNames[i]);
			}

			System.out.println("TEMP: BOTTOM PANEL delete >> " + removeCounter);
			for(int i = 0; i < removeCounter; i++) {
				System.out.println("TEMP: BOTTOM PANEL delete names >> " + removeResourceNames[i]);
			}
*/

			int counters[] = new int[2];
			counters[0] =  addCounter;
			counters[1] =  removeCounter;
			return counters;
		}
	}
}
