package tdspp.RenderingAgent;

import Prism.core.*;
import tdspp.util.*;
import java.awt.Image;
import java.util.Vector;

/**
 * The rendering agent component. Makes use of class RenderingAgentImp.
 *
 * @see		RenderingAgentImp
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 18 Feb 2002
 *
*/

public class RenderingAgent extends AbstractImplementation {
	/**
	 * The RenderingAgentImp object
	 *
	 */
	public RenderingAgentImp renderingAgentIO;

	/**
	 * Default constructor
	 */
	public RenderingAgent() {
		this("RenderingAgent");
	}
	public String name;
	/**
	 * Constructor
	 *
	 */
	public RenderingAgent(String n) {
		name=n;
		if(renderingAgentIO == null) {
			renderingAgentIO = new RenderingAgentImp(this);
		}
	}

	/**
	 * set submap to view
	 */
	public void setSubmap(int submap) {
		renderingAgentIO.setSubmap(submap);
	}

	/**
	 * Handling the Requests
	 *
	 * @param r	Request
	 * @return 	void
	 *
	 */
	
	public void handle (Event n) {
		if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_GETMAPRESP)) {
			// getmap response
			Region[] regions = new Region [100];
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS);
			//System.out.println("\nGETMAPRESP: regions[24].armyRes.resources = " + regions[24].armyRes.resources);
			if(regions != null  && (renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_NORMAL || renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_GETTING) && regions[0].submapId == renderingAgentIO.submapId) {
				if(renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_GETTING) {
					renderingAgentIO.modeGUI = Constants.RENDERINGAGENT_MODE_NORMAL;
					renderingAgentIO.frm.bp.updateGUIMode();
				}
				TDSImage tdsImage = (TDSImage) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_IMAGE);
				if(tdsImage != null) {
					tdsImage.img = java.awt.Toolkit.getDefaultToolkit().getImage(tdsImage.outputName);
					renderingAgentIO.setRegions(cloneRegions(regions));
					renderingAgentIO.setTDSImage(tdsImage);
				}
				renderingAgentIO.refresh();
				//System.out.println("N getmapresp received");
			}
		} else if (n.name .equals(tdspp.util .MessageConstants .MESSAGE_NAME_UPDATEUI )) {
			Region[] regions;
			//= new Region [100];
			Region[] clonedRegions;
			//= new Region [100];
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_SETMAP_REGIONS1 );
			clonedRegions = (Region[]) regions.clone();
			System.out.println("Got cell " + regions[0]);
			//System.out.println(""+(Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_SETMAP_REGIONS1));
			/*
			for (int i=0; i<100; i++)
				if (regions[i].armyRes.resources != 0)
					System.out.println (i);
			*/
			//System.out.println("UPDATEUI: clonedRegions[24].armyRes.resources = " + clonedRegions[24].armyRes.resources);
			if(regions != null  && (renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_NORMAL || renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_GETTING) && regions[0].submapId == renderingAgentIO.submapId) {
				if(renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_GETTING) {
					renderingAgentIO.modeGUI = Constants.RENDERINGAGENT_MODE_NORMAL;
					renderingAgentIO.frm.bp.updateGUIMode();
				}
				renderingAgentIO.setRegions(cloneRegions(regions));
				renderingAgentIO.refresh();
				//System.out.println("N updateui received");
			}
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_SIMULATEFIGHTRESP)) {
			Region[] regions = new Region [100];
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETATTR_REGION);
			//System.out.println("UI: regions[24].armyRes.resources = " + regions[24].armyRes.resources);
			if(regions != null && (renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_SIMULATION || renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_STARTSIM)) {
				renderingAgentIO.setRegions(regions);
				renderingAgentIO.refresh();
				//System.out.println("N simfightresp received");
				renderingAgentIO.showSimulation(true);
			}
			//System.out.println("UI: regions[24].armyRes.resources = " + regions[24].armyRes.resources);
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_SIMULATEFIGHTRESPFINAL)) {
			Region[] regions = new Region [100];
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETATTR_REGION);
/*
			for (int i=0; i<Constants.REPOSITORY_CELLS_PER_SUBMAP*Constants.REPOSITORY_CELLS_PER_SUBMAP ; i++){
				Region reg = new Region ();
				reg = (Region) regions[i].clone();
				//System.out.print("updated cell "+reg.x+" "+reg.y);
				//System.out.println(" value resources is "+reg.armyRes.resources);
				Request req = new Request(tdspp.util.MessageConstants.MESSAGE_NAME_SETATTR);
				req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_SETATTR_REGION,reg);
				send (req);
				//if (i== 24) System.out.println ("24th region is "+reg.armyRes.resources);
			}
*/
			//Request newreq = new Request ("printRegion");
			//send (newreq);
			//System.out.println("simfightFINAL-ui: regions[24].armyRes.resources = " + regions[24].armyRes.resources);
			if(regions != null && renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_SIMULATION) {
				renderingAgentIO.setRegions(regions);
				renderingAgentIO.refresh();
				//System.out.println("N simfightrespfinal received");
				renderingAgentIO.showSimulation(false);
			}
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_DONTSAVEFIGHTRESP)) {
			Region[] regions = new Region [100];
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS);
			if(regions != null && renderingAgentIO.modeGUI == Constants.RENDERINGAGENT_MODE_NORMAL) {
				renderingAgentIO.setRegions(regions);
				renderingAgentIO.refresh();
				//System.out.println("N dontsavesimfightresp received");
			}
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_CALLUIUPDATE)) {
		   // call ui update
   			Event req = new Event(tdspp.util.MessageConstants.MESSAGE_NAME_REFRESHREGIONS );
   			req.eventType=PrismConstants.REQUEST;
   			req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAP_SUBMAPID,new Integer(renderingAgentIO.submapId));
   			send(req);
 		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_ADVISEDEPLOYMENTRESP)) {
			// show result
			Vector regionVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_DEPLOYRESPREGION);
			Vector levelVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_DEPLOYRESPLEVEL);
			String old = renderingAgentIO.frm.tp.text;
			renderingAgentIO.frm.tp.text = tdspp.util.Constants.TOPANEL_STRING_VALIDDEPLOY;
			renderingAgentIO.showDeployAdvice(regionVec,levelVec);
			renderingAgentIO.frm.tp.text = old;
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGYVALIDRESP)) {
			// show valid
			String old = renderingAgentIO.frm.tp.text;
			renderingAgentIO.frm.tp.text = tdspp.util.Constants.TOPANEL_STRING_VALIDSTRATEGY;
			renderingAgentIO.showDeployAdvice(new Vector(), new Vector());
			renderingAgentIO.frm.tp.text = old;
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGYINVALIDRESP)) {
			// show invalid
			Vector regionVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_INVALIDRESPREGION);
			Vector levelVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_INVALIDRESPLEVEL);
			renderingAgentIO.showDeployAdvice(regionVec,levelVec);
		}
	}

	/**
	 * make a clone of the regions array
	 * @return 	void
	 *
	 */
	public Region[] cloneRegions(Region[] regions) {
		Region[] newVal = new Region [100];
		newVal = (Region[]) regions.clone();
		for(int i = 0; i < regions.length; i++){
			newVal[i] = (Region) newVal[i].clone();
		}
		//System.out.println("cloneRegions: regions[0].armyRes.resources = "+regions[0].armyRes.resources);
		//System.out.println("cloneRegions: newVal[0].armyRes.resources = "+newVal[0].armyRes.resources);
		return newVal;
	}

	/**
	 * Show the initial GUI
	 * @return 	void
	 *
	 */
	public void start () {
		int id;
		try {
			id = Integer.parseInt(name.substring(name.length()-1));
		} catch(Exception e) {
			id = -1;
		}
		if(id != -1) {
			id = ((id/2)*8)+((id%2)*2);
			int arr[] = { id, id+1, id+4, id+5 };
			this.setMySubmaps(arr);
			this.setSubmap(id);
		} else {
			int arr[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
			this.setMySubmaps(arr);
			this.setSubmap(0);
		}
		this.renderingAgentIO.show();
	}

	/**
	 * Set my submaps
	 */
	public void setMySubmaps(int submaps[]) {
		this.renderingAgentIO.setMySubmaps(submaps);
	}

}
