
package tdspp.RenderingAgent;

import java.util.*;
import tdspp.util.*;
import Prism.core.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
/**
 * The top panel
 * This is defined as a local class as it is used only by the RenderingAgent.
 */

public class TopPanel extends Panel implements ImageObserver {
	/**
	 * Text shown on the screen.
	 */
	public String text;

	/**
	 * Parent Rendering Agent.
	 */
	public RenderingAgentImp parent;

	/**
	 * The parent frame
	 */
	public TDSMainFrame frm;

	/**
	 * Image error occurred
	 */
	boolean imageError;

	/*int locatorX;
	int locatorY;
*/
	/**
	 * Constructor
	 */
	public TopPanel(RenderingAgentImp par, TDSMainFrame pfrm) {
		super();
		parent = par;
		frm = pfrm;
		text = tdspp.util.Constants.TOPANEL_STRING_FETCHINGDATA;
		imageError = false;
		setLayout(null);
		addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent me) {
				if(parent.regions == null) return;
				int arrowx = (me.getX() - tdspp.util.Constants.MAINFRAME_MAP_BORDER_X)/tdspp.util.Constants.MAINFRAME_CELL_SIDE;
				int arrowy = (me.getY() - tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y)/(tdspp.util.Constants.MAINFRAME_CELL_SIDE * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP);
				int x = me.getX() - tdspp.util.Constants.MAINFRAME_MAP_BORDER_X;
				int y = me.getY() - tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y;
				int oldX = TopPanel.this.frm.cellX;
				int oldY = TopPanel.this.frm.cellY;
/*				System.out.println("y " + y);
				System.out.println("arrowy " + arrowy);
				System.out.println("" + tdspp.util.Constants.MAINFRAME_CELL_SIDE +  "  " + tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP);
*/				if(arrowy > 0) {
					if(arrowx == tdspp.util.Constants.TOPPANEL_ARROW_WEST) {
						System.out.println("GOING WEST");
						if(parent.submapId % tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != 0) {
							drawGrid(false);
							parent.submapId -= 1;
							frm.checkSubmapMine();
							//drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_WEST,null);
							Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_GETMAP);
							req.eventType=PrismConstants.REQUEST;
							req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAP_SUBMAPID,new Integer(parent.submapId));
							parent.parent.send(req);
							parent.modeGUI = tdspp.util.Constants.RENDERINGAGENT_MODE_GETTING;
							frm.bp.updateGUIMode();
							drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_ALL,null);

							frm.tp.repaint();

						}
						else
							System.out.println("cant WEST");
					} else if(arrowx == tdspp.util.Constants.TOPPANEL_ARROW_NORTH) {
						System.out.println("GOING north");
						if(parent.submapId / tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != 0) {
							//drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_NORTH,null);
							drawGrid(false);
							parent.submapId -= tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS;
							frm.checkSubmapMine();
							Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_GETMAP);
							req.eventType=PrismConstants.REQUEST;
							req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAP_SUBMAPID,new Integer(parent.submapId));
							parent.parent.send(req);
							parent.modeGUI = tdspp.util.Constants.RENDERINGAGENT_MODE_GETTING;
							frm.bp.updateGUIMode();
							frm.tp.repaint();
							drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_ALL,null);
						}
						else
							System.out.println("cant north");
					} else if(arrowx == tdspp.util.Constants.TOPPANEL_ARROW_EAST) {
						System.out.println("GOING east");
						if(parent.submapId % tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != (tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS - 1)) {
							//drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_EAST,null);
							drawGrid(false);
							parent.submapId += 1;
							frm.checkSubmapMine();
							Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_GETMAP);
							req.eventType=PrismConstants.REQUEST;
							req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAP_SUBMAPID,new Integer(parent.submapId));
							parent.parent.send(req);
							parent.modeGUI = tdspp.util.Constants.RENDERINGAGENT_MODE_GETTING;
							frm.bp.updateGUIMode();
							frm.tp.repaint();
							drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_ALL,null);
						}
						else
							System.out.println("cant east");

					} else if(arrowx == tdspp.util.Constants.TOPPANEL_ARROW_SOUTH) {
						System.out.println("GOING south");
						if(parent.submapId / tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != (tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS - 1)) {
							drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_SOUTH,null);
							drawGrid(false);
							parent.submapId += tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS;
							frm.checkSubmapMine();
							Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_GETMAP);
							req.eventType=PrismConstants.REQUEST;
							req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAP_SUBMAPID,new Integer(parent.submapId));
							parent.parent.send(req);
							parent.modeGUI = tdspp.util.Constants.RENDERINGAGENT_MODE_GETTING;
							frm.bp.updateGUIMode();
							frm.tp.repaint();
							drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_ALL,null);
						}
						else
							System.out.println("cantsouth");
					}
				}
				else {
					Graphics g = TopPanel.this.getGraphics();
					if(oldX != -1) TopPanel.this.paintCell(oldX,oldY,g);
					if(x > 0 && y > 0) {
//						System.out.println("TEMP: TOP PANEL: mousex value " + x);
						x /= tdspp.util.Constants.MAINFRAME_CELL_SIDE;
						y /= tdspp.util.Constants.MAINFRAME_CELL_SIDE;
//						System.out.println("TEMP: TOP PANEL: x value " + x);
						if(x < tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP) {
							TopPanel.this.frm.cellX = x;
							TopPanel.this.frm.cellY = y;
							TopPanel.this.paintCell(x,y,g);
							if(TopPanel.this.parent.moveFlag) {
								//System.out.println("Choose new....");
								TopPanel.this.parent.moveFlag = false;
								Region regTo = new Region();
								regTo = TopPanel.this.parent.regions[frm.cellX * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP + frm.cellY];
								//System.out.println("adding parameter...." + regTo);
								TopPanel.this.parent.incompleteReq.addParameter(tdspp.util.MessageConstants.PARAM_NAME_MOVERESOURCES_TOREGION,regTo);
								parent.parent.send(TopPanel.this.parent.incompleteReq);
								//System.out.println("populating");
								Region regFrom = new Region();
								regFrom = (Region)TopPanel.this.parent.incompleteReq.getParameter(tdspp.util.MessageConstants.PARAM_NAME_MOVERESOURCES_FROMREGION);
								doMove(regFrom,regTo,(String [])TopPanel.this.parent.incompleteReq.getParameter(tdspp.util.MessageConstants.PARAM_NAME_MOVERESOURCES_RESOURCENAMES));

							}
						}
					}

				}
			}

			});
	}

	private void doMove(Region regFrom, Region regTo, String[] resourceNames) {
//		System.out.println("TEMP : TOP PANEL: in do Move ......." + resourceNames.length);
		for(int i = 0; i < resourceNames.length; i++) {
			if(resourceNames[i] == null)
				break;
//			System.out.println("TEMP : TOP PANEL: in do Move ......." + resourceNames[i]);
			if(resourceNames[i].equalsIgnoreCase(tdspp.util.Constants.ARMYRESOURCESNAMES[0])){
					regFrom.armyRes.removeInfantry();
					regTo.armyRes.setInfantry();
			}
			if(resourceNames[i].equalsIgnoreCase(tdspp.util.Constants.ARMYRESOURCESNAMES[1])){
					regFrom.armyRes.removeTank();
					regTo.armyRes.setTank();
			}
			if(resourceNames[i].equalsIgnoreCase(tdspp.util.Constants.ARMYRESOURCESNAMES[2])){
					regFrom.armyRes.removeMineField();
					regTo.armyRes.setMineField();
			}
			if(resourceNames[i].equalsIgnoreCase(tdspp.util.Constants.ARMYRESOURCESNAMES[3])){
					regFrom.armyRes.removeEnemyInfantry();
					regTo.armyRes.setEnemyInfantry();
			}
			if(resourceNames[i].equalsIgnoreCase(tdspp.util.Constants.ARMYRESOURCESNAMES[4])){
					regFrom.armyRes.removeEnemyTank();
					regTo.armyRes.setEnemyTank();
			}
			//System.out.println("Region From ......");
			//System.out.println(regFrom);
			//System.out.println("Region To ......");
			//System.out.println(regTo);
			updateCell(regFrom);
			updateCell(regTo);
		}
	}

	/**
	 * paint cell
	 */
	void paintCell(int i, int j, Graphics g) {
		int x = tdspp.util.Constants.MAINFRAME_MAP_BORDER_X, y = tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y;
		// g.setColor(Color.white);
		// g.fillRect(x + (i * tdspp.util.Constants.MAINFRAME_CELL_SIDE),y + (j * tdspp.util.Constants.MAINFRAME_CELL_SIDE),tdspp.util.Constants.MAINFRAME_CELL_SIDE,tdspp.util.Constants.MAINFRAME_CELL_SIDE);
		g.setColor(Color.black);
		//g.clearRect(x + (i * tdspp.util.Constants.MAINFRAME_CELL_SIDE),y + (j * tdspp.util.Constants.MAINFRAME_CELL_SIDE),tdspp.util.Constants.MAINFRAME_CELL_SIDE,tdspp.util.Constants.MAINFRAME_CELL_SIDE);
		g.drawRect(x + (i * tdspp.util.Constants.MAINFRAME_CELL_SIDE),y + (j * tdspp.util.Constants.MAINFRAME_CELL_SIDE),tdspp.util.Constants.MAINFRAME_CELL_SIDE,tdspp.util.Constants.MAINFRAME_CELL_SIDE);
		Region reg = new Region();
		reg = parent.regions[(i * tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP) + j];
		if(frm.cellX == i && frm.cellY == j) {
			g.setColor(Color.white);
			g.setXORMode(Color.black);
			g.drawRect(x + (i * tdspp.util.Constants.MAINFRAME_CELL_SIDE)+1,y + (j * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + 1,tdspp.util.Constants.MAINFRAME_CELL_SIDE-2,tdspp.util.Constants.MAINFRAME_CELL_SIDE-2);
			g.setPaintMode();
		}
		drawIcons(reg,g,false);

	}

	/**
	 * The paint method
	 */
	public void paint(Graphics g) {
		super.paint(g);
		if(parent.modeGUI == tdspp.util.Constants.RENDERINGAGENT_MODE_GETTING || parent.regions == null) {
			// draw the border of the map
			g.drawRect(tdspp.util.Constants.MAINFRAME_MAP_BORDER_X,tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y,tdspp.util.Constants.MAINFRAME_MAP_SIDE,tdspp.util.Constants.MAINFRAME_MAP_SIDE);
			g.drawString(text,(this.getSize().width-50)/2,this.getSize().height/2);
		} else {
			// draw image
			if(!imageError && parent.tdsImage.img != null && prepareImage(parent.tdsImage.img,-1,-1,this)) {
				// g.drawImage(parent.image,tdspp.util.Constants.MAINFRAME_MAP_BORDER,tdspp.util.Constants.MAINFRAME_MAP_BORDER,tdspp.util.Constants.MAINFRAME_MAP_SIDE,tdspp.util.Constants.MAINFRAME_MAP_SIDE,0,0,tdspp.util.Constants.MAINFRAME_MAP_SIDE,tdspp.util.Constants.MAINFRAME_MAP_SIDE,this);
				g.drawImage(parent.tdsImage.img,tdspp.util.Constants.MAINFRAME_MAP_BORDER_X,tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y,tdspp.util.Constants.MAINFRAME_MAP_SIDE,tdspp.util.Constants.MAINFRAME_MAP_SIDE,this);
			}
			for(int i = 0; i < tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP; i++)
				for(int j = 0; j < tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP; j++)
					paintCell(i,j,g);
		}
		drawMovers(tdspp.util.Constants.TOPPANEL_ARROW_ALL,g);
	}

	/**
	 * update a particular cell
	 */
	public void updateCell(Region reg) {
		Graphics g = this.getGraphics();
		paintCell(reg.x,reg.y,g);
		Prism.core.Event req = new Prism.core.Event(tdspp.util.MessageConstants.MESSAGE_NAME_SETATTR);
		req.eventType=PrismConstants.REQUEST;
		req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_SETATTR_REGION,reg);
		parent.parent.send(req);
	}

	/**
	 * update screen
	 */
	public void update(Graphics g) {
		paint(g);
	}

	/**
	 * Image update routine
	 */
	public boolean imageUpdate(Image img, int flags, int x, int y, int width, int height) {
		if(img != parent.tdsImage.img) return true;
		if((flags & SOMEBITS) != 0) {
			repaint(x, y, width, height);
		}
		else if((flags & ABORT) != 0) {
			imageError = true;
			repaint();
		}
		return (flags & (ALLBITS|ABORT)) == 0;
	}

	/**
	 * Draw mover arrows
	 */
	public void drawMovers(short which, Graphics g) {
		if(g == null) g = this.getGraphics();
		int x = tdspp.util.Constants.MAINFRAME_MAP_BORDER_X, y = tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y;
		drawGrid(true);
		if(which == tdspp.util.Constants.TOPPANEL_ARROW_ALL) {

			if(parent.submapId % tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != 0) {
				g.setColor(Color.black);
				drawLeftArrow(x ,y + (tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE, g);
			}
			else {
				g.setColor(Color.white);
				drawLeftArrow(x ,y + (tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE, g);
			}
			if(parent.submapId / tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != 0) {
				g.setColor(Color.black);
				drawUpArrow(x + tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE), g);
			}
			else {
				g.setColor(Color.white);
				drawUpArrow(x + tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE), g);
			}

			if(parent.submapId / tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != (tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS - 1)) {
				g.setColor(Color.black);
				drawDownArrow(x + 2*tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE), g);
			}
			else {
				g.setColor(Color.white);
				drawDownArrow(x + 2*tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE), g);
			}
			if(parent.submapId % tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS != (tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS - 1)) {
				g.setColor(Color.black);
				drawRightArrow(x + 3*tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE), g);
			}
			else {
				g.setColor(Color.white);
				drawRightArrow(x + 3*tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE), g);
			}
		}

		/*else if(which == tdspp.util.Constants.TOPPANEL_ARROW_NORTH) {
			g.setColor(Color.white);
			drawUpArrow(x + tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE));
		} else if(which == tdspp.util.Constants.TOPPANEL_ARROW_SOUTH) {
			g.setColor(Color.white);
			drawDownArrow(x + 2*tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE));
		} else if(which == tdspp.util.Constants.TOPPANEL_ARROW_WEST) {
			g.setColor(Color.white);
			drawRightArrow(x + 3*tdspp.util.Constants.MAINFRAME_CELL_SIDE,y + ((tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE));
		} else if(which == tdspp.util.Constants.TOPPANEL_ARROW_EAST) {
			g.setColor(Color.white);
			drawLeftArrow(x ,y + (tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP+1) * tdspp.util.Constants.MAINFRAME_CELL_SIDE);
		}*/

	}

	public void drawGrid(boolean type) {
		Graphics g = null;
		if(g == null) g = this.getGraphics();

		g.setColor(Color.black);
		int i,j;
		for(i = 0; i < tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS; i++) {
			for(j = 0; j < tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS; j++) {
				if(frm.checkSubmapMine(j * tdspp.util.Constants.REPOSITORY_NUMBER_OF_ROWS + i))
					g.setColor(Color.green);
				else
					g.setColor(Color.red);
				g.fillRect(tdspp.util.Constants.LOCATOR_GRID_X + i * tdspp.util.Constants.LOCATOR_GRID_CELL,tdspp.util.Constants.LOCATOR_GRID_Y + j * tdspp.util.Constants.LOCATOR_GRID_CELL, tdspp.util.Constants.LOCATOR_GRID_CELL, tdspp.util.Constants.LOCATOR_GRID_CELL);
				g.setColor(Color.black);
				g.drawRect(tdspp.util.Constants.LOCATOR_GRID_X + i * tdspp.util.Constants.LOCATOR_GRID_CELL,tdspp.util.Constants.LOCATOR_GRID_Y + j * tdspp.util.Constants.LOCATOR_GRID_CELL, tdspp.util.Constants.LOCATOR_GRID_CELL, tdspp.util.Constants.LOCATOR_GRID_CELL);
//					g.drawLine(tdspp.util.Constants.LOCATOR_GRID_X + i * tdspp.util.Constants.LOCATOR_GRID_CELL,tdspp.util.Constants.LOCATOR_GRID_Y,tdspp.util.Constants.LOCATOR_GRID_X + i * tdspp.util.Constants.LOCATOR_GRID_CELL, tdspp.util.Constants.LOCATOR_GRID_Y + tdspp.util.Constants.LOCATOR_GRID_CELL * 4);

			}
		}

		int x = parent.submapId % 4;
		int y = parent.submapId / 4;
		//System.out.println("FOr submao " + parent.submapId + " X is >>>>>> " + x + " and Y is >>>>>>>>>" + y);
		if(type) {
			g.setColor(Color.black);
			g.fillRect(tdspp.util.Constants.LOCATOR_GRID_X + (x * tdspp.util.Constants.LOCATOR_GRID_CELL), tdspp.util.Constants.LOCATOR_GRID_Y + (y * tdspp.util.Constants.LOCATOR_GRID_CELL), tdspp.util.Constants.LOCATOR_GRID_CELL, tdspp.util.Constants.LOCATOR_GRID_CELL);
		}
	}
	/**
	 * Draw Arrows for the resources
	 */
	public void drawLeftArrow(int pivotX, int pivotY, Graphics g) {
		if(g == null) g = this.getGraphics();
		int bias = tdspp.util.Constants.MAINFRAME_CELL_SIDE/4;
		g.drawLine(pivotX + bias,pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE/2, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - bias);
		g.drawLine(pivotX + bias,pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE/2, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias,pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias);
		g.drawLine(pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - bias, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias,pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias);



		int verticesX[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];
		int verticesY[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];

		verticesX[0] = pivotX + bias;
		verticesY[0] = pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE/2;

		verticesX[1] = pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias;
		verticesY[1] = pivotY - bias;

		verticesX[2] = pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias;
		verticesY[2] = pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias;



		g.fillPolygon(verticesX,verticesY,tdspp.util.Constants.TOPPANEL_TRIANGLE);

	}

	/**
	 * Draw Arrows for the resources
	 */
	public void drawUpArrow(int pivotX, int pivotY, Graphics g) {
		if(g == null) g = this.getGraphics();
		int bias = tdspp.util.Constants.MAINFRAME_CELL_SIDE/4;
		g.drawLine(pivotX + bias,pivotY - bias, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - bias);
		g.drawLine(pivotX + bias,pivotY - bias, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE/2, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias);
		g.drawLine(pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE/2, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - bias);


		int verticesX[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];
		int verticesY[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];

		verticesX[0] = pivotX + bias;
		verticesY[0] = pivotY - bias;

		verticesX[1] = pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias;
		verticesY[1] = pivotY - bias;

		verticesX[2] = pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE/2;
		verticesY[2] = pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias;



		g.fillPolygon(verticesX,verticesY,tdspp.util.Constants.TOPPANEL_TRIANGLE);

	}


	/**
	 * Draw Arrows for the resources
	 */
	public void drawDownArrow(int pivotX, int pivotY, Graphics g ) {

		if(g == null) g = this.getGraphics();
		int bias = tdspp.util.Constants.MAINFRAME_CELL_SIDE/4;
		g.drawLine(pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE/2,pivotY - bias, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE  + bias);
		g.drawLine(pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE/2,pivotY - bias, pivotX + bias, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias);
		g.drawLine(pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias,  pivotX + bias, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias);


		int verticesX[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];
		int verticesY[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];

		verticesX[0] = pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE/2;
		verticesY[0] = pivotY - bias;

		verticesX[1] = pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias;
		verticesY[1] = pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE  + bias;

		verticesX[2] = pivotX + bias;
		verticesY[2] = pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias;



		g.fillPolygon(verticesX,verticesY,tdspp.util.Constants.TOPPANEL_TRIANGLE);

	}


	public void drawRightArrow(int pivotX, int pivotY, Graphics g) {
		if(g == null) g = this.getGraphics();
		int bias = tdspp.util.Constants.MAINFRAME_CELL_SIDE/4;
		g.drawLine(pivotX + bias, pivotY - bias, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE/2);
		g.drawLine(pivotX + bias,pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias, pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias, pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE/2);
		g.drawLine(pivotX + bias, pivotY - bias, pivotX + bias,pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias);



		int verticesX[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];
		int verticesY[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];

		verticesX[0] = pivotX + bias;
		verticesY[0] = pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE + bias;

		verticesX[1] = pivotX + bias;
		verticesY[1] = pivotY - bias;

		verticesX[2] = pivotX + tdspp.util.Constants.MAINFRAME_CELL_SIDE - bias;
		verticesY[2] = pivotY - tdspp.util.Constants.MAINFRAME_CELL_SIDE/2;



		g.fillPolygon(verticesX,verticesY,tdspp.util.Constants.TOPPANEL_TRIANGLE);

	}


	/**
	 * Draw Icons for the resources
	 */
	public boolean drawIcons(Region reg, Graphics g, boolean erase) {
		int x = tdspp.util.Constants.MAINFRAME_MAP_BORDER_X, y = tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y;
		if(reg.armyRes.isInfantry()) drawFriendlyTroop(x + (reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE)+ tdspp.util.Constants.TOPPANEL_TROOPOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TROOPOFFSET, reg.armyRes.getTotalState(), erase);
		if(reg.armyRes.isEnemyInfantry()) drawEnemyTroop(x + (reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TROOPOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TROOPOFFSET, reg.armyRes.getTotalState(), erase);
		if(reg.armyRes.isTank()) drawFriendlyTank (x + (reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TANKOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TANKOFFSET, reg.armyRes.getTotalState(), erase);
		if(reg.armyRes.isEnemyTank()) drawEnemyTank (x + (reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TANKOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TANKOFFSET, reg.armyRes.getTotalState(), erase);
		if(reg.armyRes.isMineField()) drawMineField(x + (reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_MINEOFFSETX,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_MINEOFFSETY, reg.armyRes.getTotalState(), erase);
		return true;
	}

	/**
	public boolean drawIcons(Region reg, Graphics g) {
		int x = tdspp.util.Constants.MAINFRAME_MAP_BORDER, y = tdspp.util.Constants.MAINFRAME_MAP_BORDER;


		if(reg.armyRes.isInfantry()) drawFriendlyTroop((reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + (tdspp.util.Constants.MAINFRAME_CELL_SIDE/5) + tdspp.util.Constants.TOPPANEL_TROOPOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TROOPOFFSET, reg.armyRes.getTotalState());
		//else eraseFriendlyTroop((reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + (tdspp.util.Constants.MAINFRAME_CELL_SIDE/5) + TROOPOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + TROOPOFFSET);

		if(reg.armyRes.isEnemyInfantry()) drawEnemyTroop((reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + (tdspp.util.Constants.MAINFRAME_CELL_SIDE/5) + tdspp.util.Constants.TOPPANEL_TROOPOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TROOPOFFSET, reg.armyRes.getTotalState());

		if(reg.armyRes.isTank()) drawFriendlyTank ((reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + (tdspp.util.Constants.MAINFRAME_CELL_SIDE/5) + tdspp.util.Constants.TOPPANEL_TANKOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TANKOFFSET, reg.armyRes.getTotalState());

		if(reg.armyRes.isEnemyTank()) drawEnemyTank ((reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + (tdspp.util.Constants.MAINFRAME_CELL_SIDE/5) + tdspp.util.Constants.TOPPANEL_TANKOFFSET,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_TANKOFFSET, reg.armyRes.getTotalState());

		if(reg.armyRes.isMineField()) drawMineField((reg.x * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + (tdspp.util.Constants.MAINFRAME_CELL_SIDE/5) + tdspp.util.Constants.TOPPANEL_MINEOFFSETX,y + (reg.y * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + tdspp.util.Constants.TOPPANEL_MINEOFFSETY, reg.armyRes.getTotalState());

		return true;
	}
	*/

	/**
	 * Draw Friendly Troop Icon
	 */
	private void drawFriendlyTroop(int pivotX, int pivotY, float color, boolean erase) {
		Graphics g = this.getGraphics();
		//color = 1;
		g.setColor(new Color(0,tdspp.util.Constants.COLOR_RED, color));
		if(erase) g.setXORMode(new Color(255,255,128));
		g.drawOval(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TROOPWIDTH-1, tdspp.util.Constants.TOPPANEL_TROOPHEIGHT-1);
		g.fillOval(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TROOPWIDTH-1, tdspp.util.Constants.TOPPANEL_TROOPHEIGHT-1);

		int verticesX[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];
		int verticesY[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];

		verticesX[0] = pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH/2;
		verticesY[0] = pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT;

		verticesX[1] = pivotX;
		verticesY[1] = pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT;

		verticesX[2] = pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH;
		verticesY[2] = pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT;

		g.drawLine(pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH/2,pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT, pivotX, pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT);
		g.drawLine(pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH/2,pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT, pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH, pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT);
		g.drawLine(pivotX,pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT, pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH, pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT);

		g.fillPolygon(verticesX,verticesY,tdspp.util.Constants.TOPPANEL_TRIANGLE);

	}

	/**
	 * Draw Friendly Tank Icon
	 */
	private void drawFriendlyTank(int pivotX, int pivotY, float color, boolean erase) {
		//tank
		//color = 1;
		Graphics g = this.getGraphics();
		g.setColor(new Color(0,tdspp.util.Constants.COLOR_RED, color));
		if(erase) g.setXORMode(new Color(255,255,128));
		g.drawRect(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TANKWIDTH, tdspp.util.Constants.TOPPANEL_TANKHEIGHT);
		g.fillRect(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TANKWIDTH, tdspp.util.Constants.TOPPANEL_TANKHEIGHT);
	}


	/**
	 * Draw Enemy Troop Icon
	 */
	private void drawEnemyTroop(int pivotX, int pivotY, float color, boolean erase) {
		//face
		//color = 1;
		Graphics g = this.getGraphics();
		g.setColor(Color.red);
		if(erase) g.setXORMode(new Color(255,255,128));
		//System.out.println((pivotX-tdspp.util.Constants.TOPPANEL_TROOPWIDTH/2) + " " + (pivotY-tdspp.util.Constants.TOPPANEL_TROOPHEIGHT/2) + " " + tdspp.util.Constants.TOPPANEL_TROOPWIDTH + " " + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT);


		g.drawOval(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TROOPWIDTH-1, tdspp.util.Constants.TOPPANEL_TROOPHEIGHT-1);
		g.fillOval(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TROOPWIDTH-1, tdspp.util.Constants.TOPPANEL_TROOPHEIGHT-1);

		g.drawLine(pivotX,pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT, pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH, pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT);

		g.drawLine(pivotX, pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT, pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH/2, pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT);
		g.drawLine(pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH,pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT, pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH/2, pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT);

		int verticesX[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];
		int verticesY[] = new int [tdspp.util.Constants.TOPPANEL_TRIANGLE];

		verticesX[0] = pivotX;
		verticesY[0] = pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT;

		verticesX[1] = pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH;
		verticesY[1] = pivotY + tdspp.util.Constants.TOPPANEL_TROOPHEIGHT;

		verticesX[2] = pivotX + tdspp.util.Constants.TOPPANEL_TROOPWIDTH/2;
		verticesY[2] = pivotY + 2*tdspp.util.Constants.TOPPANEL_TROOPHEIGHT;



		g.fillPolygon(verticesX,verticesY,tdspp.util.Constants.TOPPANEL_TRIANGLE);
	}

	/**
	 * Draw Enemy Tank Icon
	 */
	private void drawEnemyTank(int pivotX, int pivotY, float color, boolean erase) {
		//tank
		//color = 1;
		Graphics g = this.getGraphics();
		g.setColor(Color.red);
		if(erase) g.setXORMode(new Color(255,255,128));
		g.drawRect(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TANKWIDTH, tdspp.util.Constants.TOPPANEL_TANKHEIGHT);
		g.fillRect(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_TANKWIDTH, tdspp.util.Constants.TOPPANEL_TANKHEIGHT);
	}


	/**
	 * Draw Mine Field Icon
	 */
	private void drawMineField(int pivotX, int pivotY, float color, boolean erase) {
		//face
		//color = 1;
		Graphics g = this.getGraphics();
		g.setColor(new Color(0,tdspp.util.Constants.COLOR_RED,color));
		if(erase) g.setXORMode(new Color(255,255,128));
		g.drawOval(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_MINERADIUS, tdspp.util.Constants.TOPPANEL_MINERADIUS);
		g.fillOval(pivotX,pivotY, tdspp.util.Constants.TOPPANEL_MINERADIUS, tdspp.util.Constants.TOPPANEL_MINERADIUS);

	}

	/**
	 * Show deployment advice
	 */
	public void showDeployAdvice(Vector regionVec, Vector levelVec) {
		int x = tdspp.util.Constants.MAINFRAME_MAP_BORDER_X, y = tdspp.util.Constants.MAINFRAME_MAP_BORDER_Y;
		Graphics g = this.getGraphics();
		for(Enumeration e = regionVec.elements(), le = levelVec.elements(); e.hasMoreElements() && le.hasMoreElements(); ) {
			int val = ((Integer)e.nextElement()).intValue();
			int i = val / tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP;
			int j = val % tdspp.util.Constants.REPOSITORY_CELLS_PER_SUBMAP;
			int pri = ((Integer)le.nextElement()).intValue();
			if(pri >= 60) g.setColor(Color.magenta);
			if(pri >= 80) g.setColor(Color.green);
			if(pri <= 40) g.setColor(Color.pink);
			if(pri <= 20) g.setColor(Color.red);
			g.drawRect(x + (i * tdspp.util.Constants.MAINFRAME_CELL_SIDE)+2,y + (j * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + 2,tdspp.util.Constants.MAINFRAME_CELL_SIDE-4,tdspp.util.Constants.MAINFRAME_CELL_SIDE-4);
			g.drawRect(x + (i * tdspp.util.Constants.MAINFRAME_CELL_SIDE)+3,y + (j * tdspp.util.Constants.MAINFRAME_CELL_SIDE) + 3,tdspp.util.Constants.MAINFRAME_CELL_SIDE-6,tdspp.util.Constants.MAINFRAME_CELL_SIDE-6);
		}
	}

}

