package tdspp.SAKBUI;

import Prism.core.*;

/**
 * The SAKBUI component. Makes use of class SAKBUIImp.
 *
 * @see		SAKBUIImp
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 18 Feb 2002
 * 
*/

public class SAKBUI extends AbstractImplementation {
	/**
	 * The SAKBUIImp object
	 *
	 */
	SAKBUIImp sakbuiIO;

	/**
	 * Default constructor
	 */
	public SAKBUI() {
		this("SAKBUI");
	}

	/**
	 * Constructor
	 * 
	 */
	public SAKBUI(String name) {
		
		if(sakbuiIO == null) {
			sakbuiIO = new SAKBUIImp(this);
		}
	}

	/**
	 * Update a particular rule in the KB.
	 * Called by: None.
	 * 
	 * @param rule	The rule to be Updated.
	 * @see 	StrategyAnalysisKBImp#updateRule
	 * @//return	void
	 * 
	*/
	public void updateRule(String factor, Integer number) {
		//System.out.println("creating request... for "+ factor);
		Event r = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_UPDATERULE );
		r.eventType=PrismConstants.REQUEST;
		r.addParameter (tdspp.util.MessageConstants.PARAM_NAME_FACTOR , factor);
		r.addParameter (tdspp.util.MessageConstants.PARAM_NAME_NUMBERVALUE , number);
		send (r);
		//System.out.println("request sent: "+ factor);
	}
	
	/**
	 * Handling the Requests
	 *
	 * @param r	Request
	 * @return 	void
	 *
	 */
	public void handle (Event r) {
		if (r.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_SHOWSAKBUI)){
			java.awt .Frame  frm = null;
			//java.awt.Frame frm = (java.awt.Frame) r.getParameter(tdspp.util.MessageConstants.PARAM_NAME_SHOWSAKBUI_PARENT);
			
			String[] factors = (String[]) tdspp.util.MessageConstants.FACTORS.clone() ;
			sakbuiIO.show(frm,factors);
			//return true;
		}
		//return false;
	}

	/**
	 * Handling the Notifications
	 *
	 * @param r	Notification
	 * @return 	void
	 *
	 */
	
}

