package tdspp.StrategyAnalysisKB;
import Prism.core.* ;
import java.util .*;

/**
 * The strategy analysis KB component. Makes use of class StrategyAnalysisKBImp.
 *
 * @see		StrategyAnalysisKBImp
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 18 Feb 2002
 * 
*/

public class StrategyAnalysisKB extends AbstractImplementation {
	/**
	 * The StrategyAnalysisKBImp object
	 *
	 */
	StrategyAnalysisKBImp saKBIO;

	/**
	 * Default constructor
	 */
	public StrategyAnalysisKB() {
		this("StrategyAnalysisKB");
	}

	public StrategyAnalysisKB (String name){
		saKBIO = new StrategyAnalysisKBImp ();
		//System.out.println ("inside SAKB");
		
	}
	
	public void start(){
		
		Event r = new Event (tdspp.util .MessageConstants.MESSAGE_NAME_GETINITIALRULES );
		r.eventType=PrismConstants.REQUEST;
		send(r);
		
	}
	
	
	/**
	 * Handling the Requests
	 *
	 * @param r	Request
	 * @return 	void
	 *
	 */
	public void handle (Event r) {
		if (r.name.equals (tdspp.util.MessageConstants.MESSAGE_NAME_GETRULES )){
			String id_name = (String) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_ID );
			//System.out.println(id_name);
			Hashtable rules = new Hashtable ();
			rules = saKBIO.getTable ();
			Event n = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_GETRULESRESP );
			n.eventType=PrismConstants.REPLY;
			n.addParameter (tdspp.util.MessageConstants.PARAM_NAME_GETRULESRESP, rules);
			n.addParameter (tdspp.util.MessageConstants.PARAM_NAME_ID , new String (id_name));
			send(n);
			//return true;
		}
		else if (r.name .equals (tdspp.util.MessageConstants.MESSAGE_NAME_STORERULE )){
			String factor = (String) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_FACTOR );
			Integer value = new Integer (0);
			value = (Integer) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_NUMBERVALUE );
			saKBIO.storeRule (factor,value);
			//System.out.println("stored");
			//return true;
		}
		else if (r.name .equals (tdspp.util.MessageConstants.MESSAGE_NAME_UPDATERULE )){
			String factor = (String) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_FACTOR );
			Integer value = new Integer (0);
			value = (Integer)r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_NUMBERVALUE );
			saKBIO.updateRule (factor,value);
			//System.out.println("Rule updated"+factor+" "+value.toString());
			//return true;
		}
		else if (r.name .equals (tdspp.util.MessageConstants.MESSAGE_NAME_DELETERULE )){
			String factor = (String) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_FACTOR );
			saKBIO.deleteRule (factor);
			//System.out.println("deleted");
			//return true;
		}
		else if (r.name.equals (tdspp.util.MessageConstants .MESSAGE_NAME_SAVESTATE )){
			//System.out.println("SaveState received");
			Event rr = new Event (tdspp.util .MessageConstants .MESSAGE_NAME_SAVESAKBSTATE );
			rr.eventType=PrismConstants.REQUEST;
			rr.addParameter (tdspp.util .MessageConstants.PARAM_NAME_ALLFACTORS , saKBIO.getFactors ());
			rr.addParameter (tdspp.util .MessageConstants .PARAM_NAME_ALLVALUES , saKBIO.getValues ());
			send (rr);
			//System.out.println("SaveSAKBState sent");
			//return true;
		}
		//return false;
		else handleN(r);
	}

	/**
	 * Handling the Notifications
	 *
	 * @param r	Notification
	 * @return 	void
	 *
	 */
	public void handleN (Event n) {
		if (n.name.equals (tdspp.util.MessageConstants.MESSAGE_NAME_TICK )){
			saKBIO.tick();
			if (saKBIO.getClock() == tdspp.util.Constants.DAY) {//once a day we log the current state of rules
				Event r = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_LOGSTATE );
				r.eventType=PrismConstants.REQUEST;
				Hashtable rules = new Hashtable ();
				rules = saKBIO.getTable ();
				r.addParameter (tdspp.util.MessageConstants.PARAM_NAME_LOGSTATE , rules);
				send(r);
			}
			//return false;
		}
		else if (n.name == "storeRules"){//to be completed once I see Repository
			Hashtable rules = new Hashtable ();
			rules = (Hashtable) n.getParameter ("rulesTable");
			saKBIO.setTable(rules);
			//return true;
		}
		else if (n.name .equals (tdspp.util .MessageConstants .MESSAGE_NAME_GETINITIALRULESRESP )){
			int factNum = ((Integer) n.getParameter (tdspp.util .MessageConstants .PARAM_NAME_NUMBERVALUE )).intValue();
			//System.out.println ("factNum is " + factNum);
			String[] factors = new String[factNum];
			Integer[] values = new Integer [factNum];
			
			factors = (String[]) n.getParameter (tdspp.util .MessageConstants .PARAM_NAME_ALLFACTORS );
			values = (Integer[]) n.getParameter (tdspp.util .MessageConstants .PARAM_NAME_ALLVALUES );
			
			saKBIO.populate (factors, values, factNum);
			//return true;
		}
		//return false;
	}
}
