package tdspp.apps;

import Prism.framework.*;
import Prism.conn.basic.*;
import Prism.conn.distribution.bottom.*;
import Prism.conn.distribution.top.*;
import Prism.util.*;

import tdspp.Clock.*;
import tdspp.DeploymentAdvisor.*;
import tdspp.Map.*;
import tdspp.RenderingAgent.*;
import tdspp.Repository.*;
import tdspp.ResourceManager.*;
import tdspp.ResourceMonitor.*;
import tdspp.SAKBUI.*;
import tdspp.SimulationAgent.*;
import tdspp.StrategyAnalysisKB.*;
import tdspp.StrategyAnalyzerAgent.*;
import tdspp.util.*;
import tdspp.Weather.*;
import tdspp.WeatherAnalyzer.*;

/**
 *
 * This is the sample main class that executes the application as the General.
 *
 */

public class commander3_1
{
	/**
	 * The main method
	 */
	public static void main(String argv[]) {
		FIFODispatch disp = new FIFODispatch(500);//size of the message queue
		Scaffold s = new Scaffold(ScaffoldConstants.DISPATCH | ScaffoldConstants.SCHEDULER);
		RoundRobinScheduler sch = new RoundRobinScheduler(disp, 5);//10 threads
		s.setScheduler(sch);
		s.setDispatch(disp);
		ArchitectureAdapter arch=new ArchitectureAdapter("comm31");
		arch.setScaffold(s);
		System.out.println("Creating the architecture");

		// creating the components


		SimulationAgent simag = new SimulationAgent("SimAgt31");
		simag.setScaffold(s);
		arch.add(simag);
		ResourceMonitor resmon = new ResourceMonitor("ResMon31");
		resmon.setScaffold(s);
		arch.add(resmon);
		StrategyAnalyzerAgent saa = new StrategyAnalyzerAgent("SAAgent31");
		saa.setScaffold(s);
		arch.add(saa);
		DeploymentAdvisor da = new DeploymentAdvisor("depAdv31");
		da.setScaffold(s);
		arch.add(da);
		SAKBUI sakbui = new SAKBUI("sakbUI31");
		sakbui.setScaffold(s);
		arch.add(sakbui);
		Connector c5 = new Connector("belowAgents31");
		c5.setScaffold(s);
		arch.add(c5);
		RenderingAgent ui = new RenderingAgent("UI2");
		//ui.setSubmap(8);//map3-1 has submapId=8;
		ui.setScaffold(s);
		arch.add(ui);
		TopBorderConnector tbc = new TopBorderConnector ("TBC31");
		tbc.connect(argv[0],new Integer(argv[1]).intValue(), argv[2]);
		tbc.setScaffold (s);
		arch.add(tbc);


		arch.weld(tbc,simag);
		arch.weld(tbc,resmon);

		arch.weld(tbc,saa);
		arch.weld(tbc,da);
		arch.weld(tbc,sakbui);
		arch.weld(simag,c5);
		arch.weld(resmon,c5);

		arch.weld(tbc,c5);
		arch.weld(saa,c5);
		arch.weld(da,c5);
		arch.weld(sakbui,c5);


		arch.weld(c5,ui);

		sch.start();
		arch.start();
	}

}