package tdspp.hq.RenderingAgent;

import Prism.core.*;
import java.awt.Image;
import java.util.Vector;

import tdspp.Clock.*;
import tdspp.DeploymentAdvisor.*;
import tdspp.Map.*;
import tdspp.Repository.*;
import tdspp.ResourceManager.*;
import tdspp.ResourceMonitor.*;
import tdspp.SAKBUI.*;
import tdspp.SimulationAgent.*;
import tdspp.StrategyAnalysisKB.*;
import tdspp.StrategyAnalyzerAgent.*;
import tdspp.util.*;
//import tdspp.hq.util.*;
import tdspp.Weather.*;
import tdspp.WeatherAnalyzer.*;

/**
 * The rendering agent component. Makes use of class RenderingAgentImp.
 *
 * @see		RenderingAgentImp
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 18 Feb 2002
 *
*/

public class RenderingAgent extends AbstractImplementation {
	/**
	 * The RenderingAgentImp object
	 *
	 */
	RenderingAgentImp renderingAgentIO;

	/**
	 * Default constructor
	 */
	public RenderingAgent() {
		this("RenderingAgent");

	}

	/**
	 * Constructor
	 *
	 */
	public RenderingAgent(String name) {

		
		System.out.println("Rendering agent");
		if(renderingAgentIO == null) {
			renderingAgentIO = new RenderingAgentImp(this);
		}
	}

	/**
	 * Handling the Requests
	 *
	 * @param r	Request
	 * @return 	void
	 *
	 */
	
	public void handle (Event n) {

		if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_GETMAPRESP)) {
			// getmap response
			int noOfCells = HQConstants.REPOSITORY_CELLS_PER_SUBMAP * HQConstants.REPOSITORY_CELLS_PER_SUBMAP;
			Region[] regions = new Region[noOfCells];
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS);
			//System.out.println("MESSAGE_NAME_GETMAPRESP received ");
			if(regions != null){
				int subMapId = regions[0].submapId;
				//System.out.println("MESSAGE_NAME_GETMAPRESP received for " + subMapId);
				if ((renderingAgentIO.modeGUI[subMapId] == HQConstants.RENDERINGAGENT_MODE_NORMAL || renderingAgentIO.modeGUI[subMapId] == HQConstants.RENDERINGAGENT_MODE_GETTING)) {
						if(renderingAgentIO.modeGUI[subMapId] == HQConstants.RENDERINGAGENT_MODE_GETTING) {
							renderingAgentIO.modeGUI[subMapId] = HQConstants.RENDERINGAGENT_MODE_NORMAL;
							renderingAgentIO.frm.bp.updateGUIMode();
						}
						TDSImage tdsImage = (TDSImage) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_IMAGE);
						tdsImage.img = java.awt.Toolkit.getDefaultToolkit().getImage(tdsImage.inputName);
						//System.out.println("submapid" + subMapId+ "tdsImage.outputName" + tdsImage.outputName);
						renderingAgentIO.setRegions(subMapId, cloneRegions(regions));
						renderingAgentIO.setTDSImage(subMapId, tdsImage);
						renderingAgentIO.refresh(subMapId);
				}
			}
		} else if (n.name .equals(tdspp.util .MessageConstants .MESSAGE_NAME_UPDATEUI )) {
			Region[] regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_SETMAP_REGIONS );

			if(regions != null) {
				int subMapId = regions[0].submapId;
				if(renderingAgentIO.modeGUI[subMapId] == HQConstants.RENDERINGAGENT_MODE_GETTING
				  && (renderingAgentIO.modeGUI[subMapId] == HQConstants.RENDERINGAGENT_MODE_NORMAL ||
				  		renderingAgentIO.modeGUI[subMapId] == HQConstants.RENDERINGAGENT_MODE_GETTING)) {

					renderingAgentIO.modeGUI[subMapId] = HQConstants.RENDERINGAGENT_MODE_NORMAL;
					renderingAgentIO.frm.bp.updateGUIMode();
				}
				renderingAgentIO.setRegions(subMapId,cloneRegions(regions));
				renderingAgentIO.refresh(subMapId);
			}
		}else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_SIMULATEFIGHTRESP)) {
			System.out.println("notification..........." + n.name);
			Region[] regions = null;
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETATTR_REGION);
			if(regions != null) {
				int subMapId = regions[0].submapId;
				if(renderingAgentIO.frm.bp.isModeGUI(HQConstants.RENDERINGAGENT_MODE_SIMULATION) ||
					renderingAgentIO.frm.bp.isModeGUI(HQConstants.RENDERINGAGENT_MODE_STARTSIM)) {
						renderingAgentIO.setRegions(subMapId ,regions);
						renderingAgentIO.refresh(subMapId );
						renderingAgentIO.showSimulation(subMapId , true);
				}
			}
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_SIMULATEFIGHTRESPFINAL)) {
			System.out.println("notification..........." + n.name);
			Region[] regions = null;
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETATTR_REGION);
			if(regions != null) {
				int subMapId = regions[0].submapId;
				if(renderingAgentIO.modeGUI[subMapId ] == HQConstants.RENDERINGAGENT_MODE_SIMULATION) {
					renderingAgentIO.setRegions(subMapId ,regions);
					renderingAgentIO.refresh(subMapId );
					renderingAgentIO.showSimulation(subMapId,false);
				}


/*				int noOfCells = HQConstants.REPOSITORY_CELLS_PER_SUBMAP * HQConstants.REPOSITORY_CELLS_PER_SUBMAP;
				Region newRegions[][];
				newRegions = new Region[HQConstants.REPOSITORY_NUMBER_OF_SUBMAPS][noOfCells];

				for(int i = 0; i < HQConstants.REPOSITORY_NUMBER_OF_SUBMAPS; i++){
					for(int j = 0; j < noOfCells; j++){
						newRegions[i][j] = regions[i * noOfCells + j];
					}
					if(renderingAgentIO.modeGUI[i] == HQConstants.RENDERINGAGENT_MODE_SIMULATION) {
						renderingAgentIO.setRegions(i,newRegions[i]);
						renderingAgentIO.refresh(i);
						renderingAgentIO.showSimulation(i,false);
					}
				}
*/

			}
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_DONTSAVEFIGHTRESP)) {
			System.out.println("notification..........." + n.name);
			Region[] regions = null;
			regions = (Region[]) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS);
			if(regions != null) {
				int subMapId = regions[0].submapId;
				if(renderingAgentIO.frm.bp.isModeGUI(HQConstants.RENDERINGAGENT_MODE_NORMAL)) {
					renderingAgentIO.setRegions(subMapId, regions);
					renderingAgentIO.refresh(subMapId);
				}
			}
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_CALLUIUPDATE)) {
		   // call ui update
			for(int i=0;i< HQConstants.REPOSITORY_NUMBER_OF_SUBMAPS; i++) {
				Event req = new Event(tdspp.util.MessageConstants.MESSAGE_NAME_REFRESHREGIONS );
				req.eventType=PrismConstants.REQUEST;
				req.addParameter(tdspp.util.MessageConstants.PARAM_NAME_GETMAP_SUBMAPID,new Integer(i));
				send(req);
			}
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_ADVISEDEPLOYMENTRESP)) {
			System.out.println("renderingAgentIO " +  renderingAgentIO.nextToAdvice + "   " + n.name);
			// show result

			Vector regionVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_DEPLOYRESPREGION);
			Vector levelVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_DEPLOYRESPLEVEL);
		//	System.out.println("regionnec" +  regionVec.size());
			renderingAgentIO.showDeployAdvice(regionVec,levelVec);
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGYVALIDRESP)) {
			// show valid
			//System.out.println("renderingAgentIO " +  renderingAgentIO.nextToAdvice + "   " + n.name);
			renderingAgentIO.showDeployAdvice(new Vector(), new Vector());
		} else if(n.name.equals(tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGYINVALIDRESP)) {
			System.out.println("renderingAgentIO " +  renderingAgentIO.nextToAdvice + "   " + n.name);
			// show invalid
			Vector regionVec = null;
			regionVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_INVALIDRESPREGION);
			Vector levelVec = null;
			levelVec = (Vector) n.getParameter(tdspp.util.MessageConstants.PARAM_NAME_INVALIDRESPLEVEL);

			renderingAgentIO.showDeployAdvice(regionVec,levelVec);
		}
	}

	/**
	 * make a clone of the regions array
	 * @return 	void
	 *
	 */
	public Region[] cloneRegions(Region[] regions) {
		Region[] newVal = (Region[]) regions.clone();
		for(int i = 0; i < regions.length; i++)
			newVal[i] = (Region) newVal[i].clone();
		return newVal;
	}

	/**
	 * Show the initial GUI
	 * @return 	void
	 *
	 */
	public void start () {
		this.renderingAgentIO.show();
	}

}
