package tdspp.util;

import java.awt.Toolkit;

public class Constants {

	/**
	 * Constants used
	 */
	public static final float COEF = (float) 0.85;
	public static final int DEPLETE_TIME_LEFT = 20;
	public static final int SUPPLY_TIME_LEFT = 100;															 
	
	public static final int DAY = 86400;
	public static String REPOSITORY_FILENAME = "C:\\Documents and Settings\\Marija\\Desktop\\eclipse\\workspace\\TDSP2P\\tdspp\\res\\repository.dat";
	public static String REPOSITORY_TEMP_OUTPUT_FILENAME = "C:\\Documents and Settings\\Marija\\Desktop\\eclipse\\workspace\\TDSP2P\\tdspp\\res\\temp.dat";
	public static final int REPOSITORY_NUMBER_OF_SUBMAPS = 16;
	public static final int REPOSITORY_NUMBER_OF_ROWS = (int) Math.sqrt(REPOSITORY_NUMBER_OF_SUBMAPS);
	public static final int REPOSITORY_CELLS_PER_SUBMAP = 10;
	
	public static final int CLOCK_DELAY = 5000;
	public static final int WEATHER_UPDATE_INTERVAL = 5;
	public static final int WEATHER_UI_UPDATE_INTERVAL = 10;

	public static final short RENDERINGAGENT_MODE_NORMAL = 0;
	public static final short RENDERINGAGENT_MODE_STARTSIM = 1;
	public static final short RENDERINGAGENT_MODE_SIMULATION = 1;
	public static final short RENDERINGAGENT_MODE_SIMACCEPT = 2;
	public static final short RENDERINGAGENT_MODE_DEPLOYADV = 3;
	public static final short RENDERINGAGENT_MODE_GETTING = 4;

	public static final int MAINFRAME_HEIGHT = Toolkit.getDefaultToolkit().getScreenSize().height < 500 ? Toolkit.getDefaultToolkit().getScreenSize().height : 295;
	public static final int MAINFRAME_WIDTH = Toolkit.getDefaultToolkit().getScreenSize().width < 500 ? Toolkit.getDefaultToolkit().getScreenSize().width : 245;
	public static final int MAINFRAME_CAPTION_HEIGHT = (new Integer(Toolkit.getDefaultToolkit().getProperty("win.frame.captionHeight","15"))).intValue();
	public static final int MAINFRAME_MAP_BORDER = MAINFRAME_WIDTH / 15;
	public static final int MAINFRAME_MAP_SIDE = (MAINFRAME_WIDTH - (2 * MAINFRAME_MAP_BORDER) - ((MAINFRAME_WIDTH - (2 * MAINFRAME_MAP_BORDER)) % REPOSITORY_CELLS_PER_SUBMAP));
	public static final int MAINFRAME_CELL_SIDE = MAINFRAME_MAP_SIDE / REPOSITORY_CELLS_PER_SUBMAP;
/*	public static final short MAINFRAME_ICON_INFANTRY[][] = {	{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																};
	public static final short MAINFRAME_ICON_TANK[][] = {	{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																};
	public static final short MAINFRAME_ICON_MINE[][] = {	{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0 },
																{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
																};
*/
	public static final int TOPPANEL_TROOPWIDTH  = 7;
	public static final int TOPPANEL_TROOPHEIGHT = 7;
	public static final int TOPPANEL_TANKWIDTH  = 7;
	public static final int TOPPANEL_TANKHEIGHT = 7;
	public static final int TOPPANEL_MINERADIUS = 7;
	public static final int TOPPANEL_TROOPOFFSET  = 3;
	public static final int TOPPANEL_TANKOFFSET  = 12;
	public static final int TOPPANEL_MINEOFFSETX = 12;
	public static final int TOPPANEL_MINEOFFSETY = 2;
	// movers direction constants
	public static final short TOPPANEL_ARROW_NORTH = 1;
	public static final short TOPPANEL_ARROW_SOUTH = 2;
	public static final short TOPPANEL_ARROW_EAST = 3;
	public static final short TOPPANEL_ARROW_WEST = 0;
	public static final short TOPPANEL_ARROW_ALL = -1;
	public static final short TOPPANEL_ARROW_NONE = 0;
	// bottom panel
	public static final String BOTTOMPANEL_BUTTON_LABELS[] = { "Operations", "CurrentCell", "AppStatus" };
	public static final String BOTTOMPANEL_BUTTON_CANCEL = "Cancel";
	public static final int    BOTTOMPANEL_BUTTON_CANCELIDX = 1;
	public static final String BOTTOMPANEL_BUTTON_ACCEPT = "Accept";
	public static final int    BOTTOMPANEL_BUTTON_ACCEPTIDX = 0;
	public static final String BOTTOMPANEL_BUTTON_REJECT = "Reject";
	public static final int    BOTTOMPANEL_BUTTON_REJECTIDX = 2;
//	public static final String BOTTOMPANEL_MENUS[][] = {{ "Simulate", "Analyze Deployment", "Analyze Strategy", "Knowledge Base" },{ "Weather Info.", "Move Resources" , "Update Resources"}, { "Show Log" , "Save State"} };
//	public static final String BOTTOMPANEL_ACTIONS[][] = {{ "tdspp.RenderingAgent.BottomPanel$SimulateAction", "tdspp.RenderingAgent.BottomPanel$DeployAction", "tdspp.RenderingAgent.BottomPanel$StrategyAction", "tdspp.RenderingAgent.BottomPanel$KBAction" },{ "tdspp.RenderingAgent.BottomPanel$WeatherAction" , "tdspp.RenderingAgent.BottomPanel$MoveAction" , "tdspp.RenderingAgent.BottomPanel$UpdateAction" }, { "tdspp.RenderingAgent.BottomPanel$LogAction" , "tdspp.RenderingAgent.BottomPanel$SaveAction" } };
	public static final String DIALOG_CHECKBOXES_updChk[] = {"Infantry" , "Tank", "Mine" };
	public static final String DIALOG_CHECKBOXES_unUpdChk[] = { "Enemy Infantry", "Enemy Tank" };

	public static final int RESOURCEMGR_XLENGTH = 4;
	public static final int RESOURCEMGR_YLENGTH = 4;
	public static final int RESOURCEMGR_QUEUESIZE = 5;

	public static final int ARMYRESOURCES_MINEFIELD = 0x00040000;
	public static final int ARMYRESOURCES_TANKFIELD = 0x00010000;
	public static final int ARMYRESOURCES_INFANTRY  = 0x00020000;
	public static final int ARMYRESOURCES_ENEMYTANK = 0x00000001;
	public static final int ARMYRESOURCES_ENEMYINFT = 0x00000002;
	public static final int TERRAINTYPE_FLAT		= 0;
	public static final int TERRAINTYPE_MOUNTAIN	= 1;
	public static final int TERRAINTYPE_SWAMP		= 2;
	public static final int TERRAINTYPE_RIVER		= 3;
	
	public static final String ARMYRESOURCESNAMES [] = { "Infantry" , "Tank" , "Mine" , "Enemy Infantry", "Enemy Tank" };
	public static final float COLOR_RED = (float) 1.0;
	public static final int DIALOG_BOXTYPE_INFO = 0;
	public static final int DIALOG_BOXTYPE_UPDATE = 1;
	public static final int DIALOG_BOXTYPE_MOVE = 2;
	public static final int TOPPANEL_TRIANGLE = 3;

	/**
	 * Temporary menu and its processing constants for updation of some data
	 */
	public static final String BOTTOMPANEL_MENUS[][] = {{ "Simulate Fight", "Advise Deployment", "Analyze Strategy", "Knowledge Base" },{ "Weather Info.", "Move Resources" , "Update Resources", "Update Data"}, { "Show Log" , "Save State"} };
	public static final String BOTTOMPANEL_ACTIONS[][] = {{ "tdspp.RenderingAgent.BottomPanel$SimulateAction", "tdspp.RenderingAgent.BottomPanel$DeployAction", "tdspp.RenderingAgent.BottomPanel$StrategyAction", "tdspp.RenderingAgent.BottomPanel$KBAction" },{ "tdspp.RenderingAgent.BottomPanel$WeatherAction" , "tdspp.RenderingAgent.BottomPanel$MoveAction" , "tdspp.RenderingAgent.BottomPanel$UpdateAction", "tdspp.RenderingAgent.BottomPanel$TempUpdateAction" }, { "tdspp.RenderingAgent.BottomPanel$LogAction" , "tdspp.RenderingAgent.BottomPanel$SaveAction" } };
	public static final int DIALOG_BOXTYPE_UPDATEDATA = 3;
	public static final String DIALOG_CHECKBOXES_updData[] = { "Enemy Infantry", "Enemy Tank" };
	public static final String DIALOG_TEXTBOXES_updData[] = { "stateAmmu", "stateFood", "statePop", "Temperature", "Humidity", "WindSpeed", "Sunlight"};
	public static final String DIALOG_LISTBOXES_updData[] = { "listType" };
	public static final String DIALOG_TERRAINTYPE_DESC[] = { "Flat", "Mountain", "Swamp", "River" };
	public static final int	   DIALOG_TERRAINTYPE_VALS[] = { TERRAINTYPE_FLAT, TERRAINTYPE_MOUNTAIN, TERRAINTYPE_SWAMP, TERRAINTYPE_RIVER };
	
	
	public static final String XMLTAG_ARMYRESOURCES_START = "<ArmyResources>";
	public static final String XMLTAG_ARMYRESOURCES_END = "</ArmyResources>";
	public static final String XMLTAG_ARMYRESOURCES_RESOURCES_START = "<resources>";
	public static final String XMLTAG_ARMYRESOURCES_RESOURCES_END = "</resources>";
	public static final String XMLTAG_ARMYRESOURCES_AMMUNITION_START = "<stateAmmunition>";
	public static final String XMLTAG_ARMYRESOURCES_AMMUNITION_END = "</stateAmmunition>";
	public static final String XMLTAG_ARMYRESOURCES_POPULATION_START = "<statePopulation>";
	public static final String XMLTAG_ARMYRESOURCES_POPULATION_END = "</statePopulation>";
	public static final String XMLTAG_ARMYRESOURCES_FOOD_START = "<stateFood>";
	public static final String XMLTAG_ARMYRESOURCES_FOOD_END = "</stateFood>";

	public static final String XMLTAG_REGION_START = "<Region>";
	public static final String XMLTAG_REGION_END = "</Region>";
	public static final String XMLTAG_REGION_X_START = "<x>";
	public static final String XMLTAG_REGION_X_END = "</x>";
	public static final String XMLTAG_REGION_Y_START = "<y>";
	public static final String XMLTAG_REGION_Y_END = "</y>";
	public static final String XMLTAG_REGION_SUBMAPID_START = "<submapid>";
	public static final String XMLTAG_REGION_SUBMAPID_END = "</submapid>";

	public static final String XMLTAG_TERRAINDESC_START = "<TerrainDesc>";
	public static final String XMLTAG_TERRAINDESC_END = "</TerrainDesc>";
	public static final String XMLTAG_TERRAINDESC_TYPE_START = "<type>";
	public static final String XMLTAG_TERRAINDESC_TYPE_END = "</type>";

	public static final String XMLTAG_WEATHERINFO_START = "<WeatherInfo>";
	public static final String XMLTAG_WEATHERINFO_END = "</WeatherInfo>";
	public static final String XMLTAG_WEATHERINFO_TEMPERATURE_START = "<temperature>";
	public static final String XMLTAG_WEATHERINFO_TEMPERATURE_END = "</temperature>";
	public static final String XMLTAG_WEATHERINFO_HUMIDITY_START = "<humidity>";
	public static final String XMLTAG_WEATHERINFO_HUMIDITY_END = "</humidity>";
	public static final String XMLTAG_WEATHERINFO_WINDSPEED_START = "<windSpeed>";
	public static final String XMLTAG_WEATHERINFO_WINDSPEED_END = "</windSpeed>";
	public static final String XMLTAG_WEATHERINFO_SUNLIGHT_START = "<sunlight>";
	public static final String XMLTAG_WEATHERINFO_SUNLIGHT_END = "</sunlight>";

	public static final int MAINFRAME_MAP_BORDER_X = MAINFRAME_WIDTH / 15;
	public static final int MAINFRAME_MAP_BORDER_Y = 2;
 	public static final int LOCATOR_GRID_X = MAINFRAME_MAP_BORDER_X + 3 * (MAINFRAME_CELL_SIDE * REPOSITORY_CELLS_PER_SUBMAP) /4 ;
	public static final int LOCATOR_GRID_Y = MAINFRAME_MAP_BORDER_Y + ((MAINFRAME_CELL_SIDE) * REPOSITORY_CELLS_PER_SUBMAP) + MAINFRAME_CELL_SIDE/8;
	public static final int LOCATOR_GRID_CELL = REPOSITORY_NUMBER_OF_ROWS + 1;
	public static final String TOPANEL_STRING_VALIDSTRATEGY = "Valid Strategy";
	public static final String TOPANEL_STRING_VALIDDEPLOY = "No Suggestions";
	public static final String TOPANEL_STRING_FETCHINGDATA = "Fetching data";

}
