package tdspp.util;

import java.io.*;

/**
 * WeatherInfo class stores the weather information required for a particular region.
 *
 * The weather information is stored as a bunch of sigificant properties like temperature, humidity etc.
 *
 * <table border=0>
 * <tr> <td style="font-weight: bold; font-size: smaller"> Belongs to </td> <td> TDS++ </td>
 * <tr> <td style="font-weight: bold; font-size: smaller"> Properties </td> <td> Utility </td>
 * </table>
 *
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 23 May 2002
 *
*/

public class WeatherInfo implements Cloneable, Serializable  {
	/**
	 * Current temperature.
	 *
	*/
	public float temperature;

	/**
	 * Humidity
	 *
	*/
	public float humidity;

	/**
	 * Wind speed
	 *
	*/
	public float windSpeed;

	/**
	 * Sunlight : This is stored as a value from a predefined set.
	 *
	*/
	public int sunlight;

	/**
	 * Constructor
	 */
	public WeatherInfo() {
		this.temperature = 0;
		this.humidity = 0;
		this.windSpeed = 0;
		this.sunlight = 0;
	}

	/**
	 * cloning function
	 */
	public Object clone() {
		Object o = null;
		try {
			o = super.clone();
		} catch(CloneNotSupportedException e) {
			e.printStackTrace(System.err);
		}
		return o;
	}

	public String toString() {
		return "Temperature : " + temperature + "Humidity : " + humidity + "Wind Speed : " + windSpeed + "Sunlight : "+ sunlight;
	}

		public String toXML(){
			String output = "";
			output += "<WeatherInfo type=class>";
			output += "<temperature type=Float>" + temperature + "</temperature>";
			output += "<humidity type=Float>" + humidity + "</humidity>";
			output += "<windSpeed type=Float>" + windSpeed + "</windSpeed>";
			output += "<sunlight type=Float>" + sunlight + "</sunlight>";
			output += "</WeatherInfo>";
			return output;
		}

}
